{-# OPTIONS_GHC -w #-}
module PrismParser where

import Data.Char
import Expressions
import Auxiliary
import ToPA

type Name          = String
data PRISMVariable = IntRange (String, Int, Int, Int)
                   | Boolean (String, Bool) deriving Show
type Variables     = [PRISMVariable]
type Globals       = Variables
type Updates       = [(String, Expression)]
type Commands      = [(Expression, String, [(Expression, Updates)])]
type Substitutions = [(String, String)]
data Module        = Module Name Variables Commands deriving Show
data PrismModel    = PrismModel Globals [Module] deriving Show

-- parser produced by Happy Version 1.18.9

data HappyAbsSyn t4 t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15 t16 t17 t18 t19 t20 t21 t22
	= HappyTerminal (Token)
	| HappyErrorToken Int
	| HappyAbsSyn4 t4
	| HappyAbsSyn5 t5
	| HappyAbsSyn6 t6
	| HappyAbsSyn7 t7
	| HappyAbsSyn8 t8
	| HappyAbsSyn9 t9
	| HappyAbsSyn10 t10
	| HappyAbsSyn11 t11
	| HappyAbsSyn12 t12
	| HappyAbsSyn13 t13
	| HappyAbsSyn14 t14
	| HappyAbsSyn15 t15
	| HappyAbsSyn16 t16
	| HappyAbsSyn17 t17
	| HappyAbsSyn18 t18
	| HappyAbsSyn19 t19
	| HappyAbsSyn20 t20
	| HappyAbsSyn21 t21
	| HappyAbsSyn22 t22

action_0 (48) = happyShift action_2
action_0 (4) = happyGoto action_3
action_0 _ = happyFail

action_1 (48) = happyShift action_2
action_1 _ = happyFail

action_2 (56) = happyShift action_6
action_2 (5) = happyGoto action_4
action_2 (6) = happyGoto action_5
action_2 _ = happyReduce_2

action_3 (67) = happyAccept
action_3 _ = happyFail

action_4 (57) = happyShift action_11
action_4 (7) = happyGoto action_9
action_4 (8) = happyGoto action_10
action_4 _ = happyReduce_5

action_5 (24) = happyShift action_8
action_5 _ = happyFail

action_6 (65) = happyShift action_7
action_6 _ = happyFail

action_7 (30) = happyShift action_18
action_7 _ = happyFail

action_8 (56) = happyShift action_6
action_8 (5) = happyGoto action_17
action_8 (6) = happyGoto action_5
action_8 _ = happyReduce_2

action_9 (63) = happyShift action_16
action_9 (9) = happyGoto action_14
action_9 (10) = happyGoto action_15
action_9 _ = happyReduce_8

action_10 (24) = happyShift action_13
action_10 _ = happyFail

action_11 (34) = happyShift action_12
action_11 _ = happyFail

action_12 (65) = happyShift action_37
action_12 _ = happyFail

action_13 (57) = happyShift action_11
action_13 (7) = happyGoto action_36
action_13 (8) = happyGoto action_10
action_13 _ = happyReduce_5

action_14 (62) = happyShift action_35
action_14 (11) = happyGoto action_33
action_14 (12) = happyGoto action_34
action_14 _ = happyReduce_13

action_15 (24) = happyShift action_32
action_15 _ = happyFail

action_16 (53) = happyShift action_29
action_16 (58) = happyShift action_30
action_16 (59) = happyShift action_31
action_16 _ = happyFail

action_17 _ = happyReduce_3

action_18 (32) = happyShift action_20
action_18 (33) = happyShift action_21
action_18 (50) = happyShift action_22
action_18 (51) = happyShift action_23
action_18 (52) = happyShift action_24
action_18 (60) = happyShift action_25
action_18 (61) = happyShift action_26
action_18 (65) = happyShift action_27
action_18 (66) = happyShift action_28
action_18 (19) = happyGoto action_19
action_18 _ = happyFail

action_19 (26) = happyShift action_54
action_19 (27) = happyShift action_55
action_19 (28) = happyShift action_56
action_19 (29) = happyShift action_57
action_19 (30) = happyShift action_58
action_19 (31) = happyShift action_59
action_19 (39) = happyShift action_60
action_19 (40) = happyShift action_61
action_19 (41) = happyShift action_62
action_19 (42) = happyShift action_63
action_19 (43) = happyShift action_64
action_19 (44) = happyShift action_65
action_19 (45) = happyShift action_66
action_19 (46) = happyShift action_67
action_19 _ = happyReduce_4

action_20 (32) = happyShift action_20
action_20 (33) = happyShift action_21
action_20 (50) = happyShift action_22
action_20 (51) = happyShift action_23
action_20 (52) = happyShift action_24
action_20 (60) = happyShift action_25
action_20 (61) = happyShift action_26
action_20 (65) = happyShift action_27
action_20 (66) = happyShift action_28
action_20 (19) = happyGoto action_53
action_20 _ = happyFail

action_21 (32) = happyShift action_20
action_21 (33) = happyShift action_21
action_21 (50) = happyShift action_22
action_21 (51) = happyShift action_23
action_21 (52) = happyShift action_24
action_21 (60) = happyShift action_25
action_21 (61) = happyShift action_26
action_21 (65) = happyShift action_27
action_21 (66) = happyShift action_28
action_21 (19) = happyGoto action_52
action_21 _ = happyFail

action_22 (33) = happyShift action_51
action_22 _ = happyFail

action_23 (33) = happyShift action_50
action_23 _ = happyFail

action_24 (33) = happyShift action_49
action_24 _ = happyFail

action_25 _ = happyReduce_48

action_26 _ = happyReduce_49

action_27 _ = happyReduce_50

action_28 _ = happyReduce_51

action_29 (65) = happyShift action_48
action_29 _ = happyFail

action_30 (65) = happyShift action_47
action_30 _ = happyFail

action_31 (65) = happyShift action_46
action_31 _ = happyFail

action_32 (63) = happyShift action_16
action_32 (9) = happyGoto action_45
action_32 (10) = happyGoto action_15
action_32 _ = happyReduce_8

action_33 (55) = happyShift action_44
action_33 (15) = happyGoto action_42
action_33 (16) = happyGoto action_43
action_33 _ = happyFail

action_34 (24) = happyShift action_41
action_34 _ = happyFail

action_35 (65) = happyShift action_40
action_35 (14) = happyGoto action_39
action_35 _ = happyFail

action_36 _ = happyReduce_6

action_37 (34) = happyShift action_38
action_37 _ = happyFail

action_38 (30) = happyShift action_93
action_38 _ = happyFail

action_39 _ = happyReduce_15

action_40 (25) = happyShift action_92
action_40 _ = happyFail

action_41 (62) = happyShift action_35
action_41 (11) = happyGoto action_91
action_41 (12) = happyGoto action_34
action_41 _ = happyReduce_13

action_42 _ = happyReduce_1

action_43 (55) = happyShift action_44
action_43 (15) = happyGoto action_90
action_43 (16) = happyGoto action_43
action_43 _ = happyReduce_23

action_44 (65) = happyShift action_89
action_44 _ = happyFail

action_45 _ = happyReduce_9

action_46 (30) = happyShift action_88
action_46 _ = happyFail

action_47 (30) = happyShift action_87
action_47 _ = happyFail

action_48 (30) = happyShift action_86
action_48 _ = happyFail

action_49 (32) = happyShift action_20
action_49 (33) = happyShift action_21
action_49 (50) = happyShift action_22
action_49 (51) = happyShift action_23
action_49 (52) = happyShift action_24
action_49 (60) = happyShift action_25
action_49 (61) = happyShift action_26
action_49 (65) = happyShift action_27
action_49 (66) = happyShift action_28
action_49 (19) = happyGoto action_85
action_49 _ = happyFail

action_50 (32) = happyShift action_20
action_50 (33) = happyShift action_21
action_50 (50) = happyShift action_22
action_50 (51) = happyShift action_23
action_50 (52) = happyShift action_24
action_50 (60) = happyShift action_25
action_50 (61) = happyShift action_26
action_50 (65) = happyShift action_27
action_50 (66) = happyShift action_28
action_50 (19) = happyGoto action_84
action_50 _ = happyFail

action_51 (32) = happyShift action_20
action_51 (33) = happyShift action_21
action_51 (50) = happyShift action_22
action_51 (51) = happyShift action_23
action_51 (52) = happyShift action_24
action_51 (60) = happyShift action_25
action_51 (61) = happyShift action_26
action_51 (65) = happyShift action_27
action_51 (66) = happyShift action_28
action_51 (19) = happyGoto action_83
action_51 _ = happyFail

action_52 (26) = happyShift action_54
action_52 (27) = happyShift action_55
action_52 (28) = happyShift action_56
action_52 (29) = happyShift action_57
action_52 (30) = happyShift action_58
action_52 (31) = happyShift action_59
action_52 (35) = happyShift action_82
action_52 (39) = happyShift action_60
action_52 (40) = happyShift action_61
action_52 (41) = happyShift action_62
action_52 (42) = happyShift action_63
action_52 (43) = happyShift action_64
action_52 (44) = happyShift action_65
action_52 (45) = happyShift action_66
action_52 (46) = happyShift action_67
action_52 _ = happyFail

action_53 (26) = happyShift action_54
action_53 (27) = happyShift action_55
action_53 (28) = happyShift action_56
action_53 (29) = happyShift action_57
action_53 (30) = happyShift action_58
action_53 (31) = happyShift action_59
action_53 (39) = happyShift action_60
action_53 (40) = happyShift action_61
action_53 (41) = happyShift action_62
action_53 (42) = happyShift action_63
action_53 _ = happyReduce_40

action_54 (32) = happyShift action_20
action_54 (33) = happyShift action_21
action_54 (50) = happyShift action_22
action_54 (51) = happyShift action_23
action_54 (52) = happyShift action_24
action_54 (60) = happyShift action_25
action_54 (61) = happyShift action_26
action_54 (65) = happyShift action_27
action_54 (66) = happyShift action_28
action_54 (19) = happyGoto action_81
action_54 _ = happyFail

action_55 (32) = happyShift action_20
action_55 (33) = happyShift action_21
action_55 (50) = happyShift action_22
action_55 (51) = happyShift action_23
action_55 (52) = happyShift action_24
action_55 (60) = happyShift action_25
action_55 (61) = happyShift action_26
action_55 (65) = happyShift action_27
action_55 (66) = happyShift action_28
action_55 (19) = happyGoto action_80
action_55 _ = happyFail

action_56 (32) = happyShift action_20
action_56 (33) = happyShift action_21
action_56 (50) = happyShift action_22
action_56 (51) = happyShift action_23
action_56 (52) = happyShift action_24
action_56 (60) = happyShift action_25
action_56 (61) = happyShift action_26
action_56 (65) = happyShift action_27
action_56 (66) = happyShift action_28
action_56 (19) = happyGoto action_79
action_56 _ = happyFail

action_57 (32) = happyShift action_20
action_57 (33) = happyShift action_21
action_57 (50) = happyShift action_22
action_57 (51) = happyShift action_23
action_57 (52) = happyShift action_24
action_57 (60) = happyShift action_25
action_57 (61) = happyShift action_26
action_57 (65) = happyShift action_27
action_57 (66) = happyShift action_28
action_57 (19) = happyGoto action_78
action_57 _ = happyFail

action_58 (32) = happyShift action_20
action_58 (33) = happyShift action_21
action_58 (50) = happyShift action_22
action_58 (51) = happyShift action_23
action_58 (52) = happyShift action_24
action_58 (60) = happyShift action_25
action_58 (61) = happyShift action_26
action_58 (65) = happyShift action_27
action_58 (66) = happyShift action_28
action_58 (19) = happyGoto action_77
action_58 _ = happyFail

action_59 (32) = happyShift action_20
action_59 (33) = happyShift action_21
action_59 (50) = happyShift action_22
action_59 (51) = happyShift action_23
action_59 (52) = happyShift action_24
action_59 (60) = happyShift action_25
action_59 (61) = happyShift action_26
action_59 (65) = happyShift action_27
action_59 (66) = happyShift action_28
action_59 (19) = happyGoto action_76
action_59 _ = happyFail

action_60 (32) = happyShift action_20
action_60 (33) = happyShift action_21
action_60 (50) = happyShift action_22
action_60 (51) = happyShift action_23
action_60 (52) = happyShift action_24
action_60 (60) = happyShift action_25
action_60 (61) = happyShift action_26
action_60 (65) = happyShift action_27
action_60 (66) = happyShift action_28
action_60 (19) = happyGoto action_75
action_60 _ = happyFail

action_61 (32) = happyShift action_20
action_61 (33) = happyShift action_21
action_61 (50) = happyShift action_22
action_61 (51) = happyShift action_23
action_61 (52) = happyShift action_24
action_61 (60) = happyShift action_25
action_61 (61) = happyShift action_26
action_61 (65) = happyShift action_27
action_61 (66) = happyShift action_28
action_61 (19) = happyGoto action_74
action_61 _ = happyFail

action_62 (32) = happyShift action_20
action_62 (33) = happyShift action_21
action_62 (50) = happyShift action_22
action_62 (51) = happyShift action_23
action_62 (52) = happyShift action_24
action_62 (60) = happyShift action_25
action_62 (61) = happyShift action_26
action_62 (65) = happyShift action_27
action_62 (66) = happyShift action_28
action_62 (19) = happyGoto action_73
action_62 _ = happyFail

action_63 (32) = happyShift action_20
action_63 (33) = happyShift action_21
action_63 (50) = happyShift action_22
action_63 (51) = happyShift action_23
action_63 (52) = happyShift action_24
action_63 (60) = happyShift action_25
action_63 (61) = happyShift action_26
action_63 (65) = happyShift action_27
action_63 (66) = happyShift action_28
action_63 (19) = happyGoto action_72
action_63 _ = happyFail

action_64 (32) = happyShift action_20
action_64 (33) = happyShift action_21
action_64 (50) = happyShift action_22
action_64 (51) = happyShift action_23
action_64 (52) = happyShift action_24
action_64 (60) = happyShift action_25
action_64 (61) = happyShift action_26
action_64 (65) = happyShift action_27
action_64 (66) = happyShift action_28
action_64 (19) = happyGoto action_71
action_64 _ = happyFail

action_65 (32) = happyShift action_20
action_65 (33) = happyShift action_21
action_65 (50) = happyShift action_22
action_65 (51) = happyShift action_23
action_65 (52) = happyShift action_24
action_65 (60) = happyShift action_25
action_65 (61) = happyShift action_26
action_65 (65) = happyShift action_27
action_65 (66) = happyShift action_28
action_65 (19) = happyGoto action_70
action_65 _ = happyFail

action_66 (32) = happyShift action_20
action_66 (33) = happyShift action_21
action_66 (50) = happyShift action_22
action_66 (51) = happyShift action_23
action_66 (52) = happyShift action_24
action_66 (60) = happyShift action_25
action_66 (61) = happyShift action_26
action_66 (65) = happyShift action_27
action_66 (66) = happyShift action_28
action_66 (19) = happyGoto action_69
action_66 _ = happyFail

action_67 (32) = happyShift action_20
action_67 (33) = happyShift action_21
action_67 (50) = happyShift action_22
action_67 (51) = happyShift action_23
action_67 (52) = happyShift action_24
action_67 (60) = happyShift action_25
action_67 (61) = happyShift action_26
action_67 (65) = happyShift action_27
action_67 (66) = happyShift action_28
action_67 (19) = happyGoto action_68
action_67 _ = happyFail

action_68 (26) = happyShift action_54
action_68 (27) = happyShift action_55
action_68 (28) = happyShift action_56
action_68 (29) = happyShift action_57
action_68 (30) = happyShift action_58
action_68 (31) = happyShift action_59
action_68 (39) = happyShift action_60
action_68 (40) = happyShift action_61
action_68 (41) = happyShift action_62
action_68 (42) = happyShift action_63
action_68 (43) = happyShift action_64
action_68 (44) = happyShift action_65
action_68 _ = happyReduce_43

action_69 (25) = happyShift action_105
action_69 (26) = happyShift action_54
action_69 (27) = happyShift action_55
action_69 (28) = happyShift action_56
action_69 (29) = happyShift action_57
action_69 (30) = happyShift action_58
action_69 (31) = happyShift action_59
action_69 (39) = happyShift action_60
action_69 (40) = happyShift action_61
action_69 (41) = happyShift action_62
action_69 (42) = happyShift action_63
action_69 (43) = happyShift action_64
action_69 (44) = happyShift action_65
action_69 (45) = happyShift action_66
action_69 (46) = happyShift action_67
action_69 _ = happyFail

action_70 (26) = happyShift action_54
action_70 (27) = happyShift action_55
action_70 (28) = happyShift action_56
action_70 (29) = happyShift action_57
action_70 (30) = happyShift action_58
action_70 (31) = happyShift action_59
action_70 (39) = happyShift action_60
action_70 (40) = happyShift action_61
action_70 (41) = happyShift action_62
action_70 (42) = happyShift action_63
action_70 (43) = happyShift action_64
action_70 _ = happyReduce_42

action_71 (26) = happyShift action_54
action_71 (27) = happyShift action_55
action_71 (28) = happyShift action_56
action_71 (29) = happyShift action_57
action_71 (30) = happyShift action_58
action_71 (31) = happyShift action_59
action_71 (39) = happyShift action_60
action_71 (40) = happyShift action_61
action_71 (41) = happyShift action_62
action_71 (42) = happyShift action_63
action_71 _ = happyReduce_41

action_72 (39) = happyShift action_60
action_72 (40) = happyShift action_61
action_72 _ = happyReduce_33

action_73 (39) = happyShift action_60
action_73 (40) = happyShift action_61
action_73 _ = happyReduce_32

action_74 _ = happyReduce_31

action_75 _ = happyReduce_30

action_76 (26) = happyShift action_54
action_76 (27) = happyShift action_55
action_76 (28) = happyShift action_56
action_76 (29) = happyShift action_57
action_76 (39) = happyShift action_60
action_76 (40) = happyShift action_61
action_76 (41) = happyShift action_62
action_76 (42) = happyShift action_63
action_76 _ = happyReduce_39

action_77 (26) = happyShift action_54
action_77 (27) = happyShift action_55
action_77 (28) = happyShift action_56
action_77 (29) = happyShift action_57
action_77 (39) = happyShift action_60
action_77 (40) = happyShift action_61
action_77 (41) = happyShift action_62
action_77 (42) = happyShift action_63
action_77 _ = happyReduce_38

action_78 (39) = happyShift action_60
action_78 (40) = happyShift action_61
action_78 (41) = happyShift action_62
action_78 (42) = happyShift action_63
action_78 _ = happyReduce_37

action_79 (39) = happyShift action_60
action_79 (40) = happyShift action_61
action_79 (41) = happyShift action_62
action_79 (42) = happyShift action_63
action_79 _ = happyReduce_34

action_80 (39) = happyShift action_60
action_80 (40) = happyShift action_61
action_80 (41) = happyShift action_62
action_80 (42) = happyShift action_63
action_80 _ = happyReduce_35

action_81 (39) = happyShift action_60
action_81 (40) = happyShift action_61
action_81 (41) = happyShift action_62
action_81 (42) = happyShift action_63
action_81 _ = happyReduce_36

action_82 _ = happyReduce_52

action_83 (23) = happyShift action_104
action_83 (26) = happyShift action_54
action_83 (27) = happyShift action_55
action_83 (28) = happyShift action_56
action_83 (29) = happyShift action_57
action_83 (30) = happyShift action_58
action_83 (31) = happyShift action_59
action_83 (39) = happyShift action_60
action_83 (40) = happyShift action_61
action_83 (41) = happyShift action_62
action_83 (42) = happyShift action_63
action_83 (43) = happyShift action_64
action_83 (44) = happyShift action_65
action_83 (45) = happyShift action_66
action_83 (46) = happyShift action_67
action_83 _ = happyFail

action_84 (23) = happyShift action_103
action_84 (26) = happyShift action_54
action_84 (27) = happyShift action_55
action_84 (28) = happyShift action_56
action_84 (29) = happyShift action_57
action_84 (30) = happyShift action_58
action_84 (31) = happyShift action_59
action_84 (39) = happyShift action_60
action_84 (40) = happyShift action_61
action_84 (41) = happyShift action_62
action_84 (42) = happyShift action_63
action_84 (43) = happyShift action_64
action_84 (44) = happyShift action_65
action_84 (45) = happyShift action_66
action_84 (46) = happyShift action_67
action_84 _ = happyFail

action_85 (23) = happyShift action_102
action_85 (26) = happyShift action_54
action_85 (27) = happyShift action_55
action_85 (28) = happyShift action_56
action_85 (29) = happyShift action_57
action_85 (30) = happyShift action_58
action_85 (31) = happyShift action_59
action_85 (39) = happyShift action_60
action_85 (40) = happyShift action_61
action_85 (41) = happyShift action_62
action_85 (42) = happyShift action_63
action_85 (43) = happyShift action_64
action_85 (44) = happyShift action_65
action_85 (45) = happyShift action_66
action_85 (46) = happyShift action_67
action_85 _ = happyFail

action_86 (32) = happyShift action_20
action_86 (33) = happyShift action_21
action_86 (50) = happyShift action_22
action_86 (51) = happyShift action_23
action_86 (52) = happyShift action_24
action_86 (60) = happyShift action_25
action_86 (61) = happyShift action_26
action_86 (65) = happyShift action_27
action_86 (66) = happyShift action_28
action_86 (19) = happyGoto action_101
action_86 _ = happyFail

action_87 (32) = happyShift action_20
action_87 (33) = happyShift action_21
action_87 (50) = happyShift action_22
action_87 (51) = happyShift action_23
action_87 (52) = happyShift action_24
action_87 (60) = happyShift action_25
action_87 (61) = happyShift action_26
action_87 (65) = happyShift action_27
action_87 (66) = happyShift action_28
action_87 (19) = happyGoto action_100
action_87 _ = happyFail

action_88 (32) = happyShift action_20
action_88 (33) = happyShift action_21
action_88 (50) = happyShift action_22
action_88 (51) = happyShift action_23
action_88 (52) = happyShift action_24
action_88 (60) = happyShift action_25
action_88 (61) = happyShift action_26
action_88 (65) = happyShift action_27
action_88 (66) = happyShift action_28
action_88 (19) = happyGoto action_99
action_88 _ = happyFail

action_89 (65) = happyShift action_40
action_89 (13) = happyGoto action_97
action_89 (14) = happyGoto action_98
action_89 _ = happyReduce_16

action_90 _ = happyReduce_24

action_91 _ = happyReduce_14

action_92 (37) = happyShift action_95
action_92 (58) = happyShift action_96
action_92 _ = happyFail

action_93 (32) = happyShift action_20
action_93 (33) = happyShift action_21
action_93 (50) = happyShift action_22
action_93 (51) = happyShift action_23
action_93 (52) = happyShift action_24
action_93 (60) = happyShift action_25
action_93 (61) = happyShift action_26
action_93 (65) = happyShift action_27
action_93 (66) = happyShift action_28
action_93 (19) = happyGoto action_94
action_93 _ = happyFail

action_94 (26) = happyShift action_54
action_94 (27) = happyShift action_55
action_94 (28) = happyShift action_56
action_94 (29) = happyShift action_57
action_94 (30) = happyShift action_58
action_94 (31) = happyShift action_59
action_94 (39) = happyShift action_60
action_94 (40) = happyShift action_61
action_94 (41) = happyShift action_62
action_94 (42) = happyShift action_63
action_94 (43) = happyShift action_64
action_94 (44) = happyShift action_65
action_94 (45) = happyShift action_66
action_94 (46) = happyShift action_67
action_94 _ = happyReduce_7

action_95 (32) = happyShift action_20
action_95 (33) = happyShift action_21
action_95 (50) = happyShift action_22
action_95 (51) = happyShift action_23
action_95 (52) = happyShift action_24
action_95 (60) = happyShift action_25
action_95 (61) = happyShift action_26
action_95 (65) = happyShift action_27
action_95 (66) = happyShift action_28
action_95 (19) = happyGoto action_115
action_95 _ = happyFail

action_96 (54) = happyShift action_114
action_96 _ = happyReduce_20

action_97 (37) = happyShift action_113
action_97 (17) = happyGoto action_111
action_97 (18) = happyGoto action_112
action_97 _ = happyReduce_26

action_98 (24) = happyShift action_110
action_98 _ = happyFail

action_99 (26) = happyShift action_54
action_99 (27) = happyShift action_55
action_99 (28) = happyShift action_56
action_99 (29) = happyShift action_57
action_99 (30) = happyShift action_58
action_99 (31) = happyShift action_59
action_99 (39) = happyShift action_60
action_99 (40) = happyShift action_61
action_99 (41) = happyShift action_62
action_99 (42) = happyShift action_63
action_99 (43) = happyShift action_64
action_99 (44) = happyShift action_65
action_99 (45) = happyShift action_66
action_99 (46) = happyShift action_67
action_99 _ = happyReduce_11

action_100 (26) = happyShift action_54
action_100 (27) = happyShift action_55
action_100 (28) = happyShift action_56
action_100 (29) = happyShift action_57
action_100 (30) = happyShift action_58
action_100 (31) = happyShift action_59
action_100 (39) = happyShift action_60
action_100 (40) = happyShift action_61
action_100 (41) = happyShift action_62
action_100 (42) = happyShift action_63
action_100 (43) = happyShift action_64
action_100 (44) = happyShift action_65
action_100 (45) = happyShift action_66
action_100 (46) = happyShift action_67
action_100 _ = happyReduce_12

action_101 (26) = happyShift action_54
action_101 (27) = happyShift action_55
action_101 (28) = happyShift action_56
action_101 (29) = happyShift action_57
action_101 (30) = happyShift action_58
action_101 (31) = happyShift action_59
action_101 (39) = happyShift action_60
action_101 (40) = happyShift action_61
action_101 (41) = happyShift action_62
action_101 (42) = happyShift action_63
action_101 (43) = happyShift action_64
action_101 (44) = happyShift action_65
action_101 (45) = happyShift action_66
action_101 (46) = happyShift action_67
action_101 _ = happyReduce_10

action_102 (32) = happyShift action_20
action_102 (33) = happyShift action_21
action_102 (50) = happyShift action_22
action_102 (51) = happyShift action_23
action_102 (52) = happyShift action_24
action_102 (60) = happyShift action_25
action_102 (61) = happyShift action_26
action_102 (65) = happyShift action_27
action_102 (66) = happyShift action_28
action_102 (19) = happyGoto action_109
action_102 _ = happyFail

action_103 (32) = happyShift action_20
action_103 (33) = happyShift action_21
action_103 (50) = happyShift action_22
action_103 (51) = happyShift action_23
action_103 (52) = happyShift action_24
action_103 (60) = happyShift action_25
action_103 (61) = happyShift action_26
action_103 (65) = happyShift action_27
action_103 (66) = happyShift action_28
action_103 (19) = happyGoto action_108
action_103 _ = happyFail

action_104 (32) = happyShift action_20
action_104 (33) = happyShift action_21
action_104 (50) = happyShift action_22
action_104 (51) = happyShift action_23
action_104 (52) = happyShift action_24
action_104 (60) = happyShift action_25
action_104 (61) = happyShift action_26
action_104 (65) = happyShift action_27
action_104 (66) = happyShift action_28
action_104 (19) = happyGoto action_107
action_104 _ = happyFail

action_105 (32) = happyShift action_20
action_105 (33) = happyShift action_21
action_105 (50) = happyShift action_22
action_105 (51) = happyShift action_23
action_105 (52) = happyShift action_24
action_105 (60) = happyShift action_25
action_105 (61) = happyShift action_26
action_105 (65) = happyShift action_27
action_105 (66) = happyShift action_28
action_105 (19) = happyGoto action_106
action_105 _ = happyFail

action_106 (26) = happyShift action_54
action_106 (27) = happyShift action_55
action_106 (28) = happyShift action_56
action_106 (29) = happyShift action_57
action_106 (30) = happyShift action_58
action_106 (31) = happyShift action_59
action_106 (39) = happyShift action_60
action_106 (40) = happyShift action_61
action_106 (41) = happyShift action_62
action_106 (42) = happyShift action_63
action_106 (43) = happyShift action_64
action_106 (44) = happyShift action_65
action_106 (45) = happyShift action_66
action_106 (46) = happyShift action_67
action_106 _ = happyReduce_44

action_107 (26) = happyShift action_54
action_107 (27) = happyShift action_55
action_107 (28) = happyShift action_56
action_107 (29) = happyShift action_57
action_107 (30) = happyShift action_58
action_107 (31) = happyShift action_59
action_107 (35) = happyShift action_126
action_107 (39) = happyShift action_60
action_107 (40) = happyShift action_61
action_107 (41) = happyShift action_62
action_107 (42) = happyShift action_63
action_107 (43) = happyShift action_64
action_107 (44) = happyShift action_65
action_107 (45) = happyShift action_66
action_107 (46) = happyShift action_67
action_107 _ = happyFail

action_108 (26) = happyShift action_54
action_108 (27) = happyShift action_55
action_108 (28) = happyShift action_56
action_108 (29) = happyShift action_57
action_108 (30) = happyShift action_58
action_108 (31) = happyShift action_59
action_108 (35) = happyShift action_125
action_108 (39) = happyShift action_60
action_108 (40) = happyShift action_61
action_108 (41) = happyShift action_62
action_108 (42) = happyShift action_63
action_108 (43) = happyShift action_64
action_108 (44) = happyShift action_65
action_108 (45) = happyShift action_66
action_108 (46) = happyShift action_67
action_108 _ = happyFail

action_109 (26) = happyShift action_54
action_109 (27) = happyShift action_55
action_109 (28) = happyShift action_56
action_109 (29) = happyShift action_57
action_109 (30) = happyShift action_58
action_109 (31) = happyShift action_59
action_109 (35) = happyShift action_124
action_109 (39) = happyShift action_60
action_109 (40) = happyShift action_61
action_109 (41) = happyShift action_62
action_109 (42) = happyShift action_63
action_109 (43) = happyShift action_64
action_109 (44) = happyShift action_65
action_109 (45) = happyShift action_66
action_109 (46) = happyShift action_67
action_109 _ = happyFail

action_110 (65) = happyShift action_40
action_110 (13) = happyGoto action_123
action_110 (14) = happyGoto action_98
action_110 _ = happyReduce_16

action_111 (64) = happyShift action_122
action_111 _ = happyFail

action_112 (24) = happyShift action_121
action_112 _ = happyFail

action_113 (38) = happyShift action_119
action_113 (65) = happyShift action_120
action_113 _ = happyFail

action_114 (60) = happyShift action_117
action_114 (61) = happyShift action_118
action_114 _ = happyFail

action_115 (26) = happyShift action_54
action_115 (27) = happyShift action_55
action_115 (28) = happyShift action_56
action_115 (29) = happyShift action_57
action_115 (30) = happyShift action_58
action_115 (31) = happyShift action_59
action_115 (36) = happyShift action_116
action_115 (39) = happyShift action_60
action_115 (40) = happyShift action_61
action_115 (41) = happyShift action_62
action_115 (42) = happyShift action_63
action_115 (43) = happyShift action_64
action_115 (44) = happyShift action_65
action_115 (45) = happyShift action_66
action_115 (46) = happyShift action_67
action_115 _ = happyFail

action_116 (32) = happyShift action_20
action_116 (33) = happyShift action_21
action_116 (50) = happyShift action_22
action_116 (51) = happyShift action_23
action_116 (52) = happyShift action_24
action_116 (60) = happyShift action_25
action_116 (61) = happyShift action_26
action_116 (65) = happyShift action_27
action_116 (66) = happyShift action_28
action_116 (19) = happyGoto action_130
action_116 _ = happyFail

action_117 _ = happyReduce_21

action_118 _ = happyReduce_22

action_119 (32) = happyShift action_20
action_119 (33) = happyShift action_21
action_119 (50) = happyShift action_22
action_119 (51) = happyShift action_23
action_119 (52) = happyShift action_24
action_119 (60) = happyShift action_25
action_119 (61) = happyShift action_26
action_119 (65) = happyShift action_27
action_119 (66) = happyShift action_28
action_119 (19) = happyGoto action_129
action_119 _ = happyFail

action_120 (38) = happyShift action_128
action_120 _ = happyFail

action_121 (37) = happyShift action_113
action_121 (17) = happyGoto action_127
action_121 (18) = happyGoto action_112
action_121 _ = happyReduce_26

action_122 _ = happyReduce_25

action_123 _ = happyReduce_17

action_124 _ = happyReduce_47

action_125 _ = happyReduce_46

action_126 _ = happyReduce_45

action_127 _ = happyReduce_27

action_128 (32) = happyShift action_20
action_128 (33) = happyShift action_21
action_128 (50) = happyShift action_22
action_128 (51) = happyShift action_23
action_128 (52) = happyShift action_24
action_128 (60) = happyShift action_25
action_128 (61) = happyShift action_26
action_128 (65) = happyShift action_27
action_128 (66) = happyShift action_28
action_128 (19) = happyGoto action_133
action_128 _ = happyFail

action_129 (26) = happyShift action_54
action_129 (27) = happyShift action_55
action_129 (28) = happyShift action_56
action_129 (29) = happyShift action_57
action_129 (30) = happyShift action_58
action_129 (31) = happyShift action_59
action_129 (39) = happyShift action_60
action_129 (40) = happyShift action_61
action_129 (41) = happyShift action_62
action_129 (42) = happyShift action_63
action_129 (43) = happyShift action_64
action_129 (44) = happyShift action_65
action_129 (45) = happyShift action_66
action_129 (46) = happyShift action_67
action_129 (47) = happyShift action_132
action_129 _ = happyFail

action_130 (26) = happyShift action_54
action_130 (27) = happyShift action_55
action_130 (28) = happyShift action_56
action_130 (29) = happyShift action_57
action_130 (30) = happyShift action_58
action_130 (31) = happyShift action_59
action_130 (38) = happyShift action_131
action_130 (39) = happyShift action_60
action_130 (40) = happyShift action_61
action_130 (41) = happyShift action_62
action_130 (42) = happyShift action_63
action_130 (43) = happyShift action_64
action_130 (44) = happyShift action_65
action_130 (45) = happyShift action_66
action_130 (46) = happyShift action_67
action_130 _ = happyFail

action_131 (54) = happyShift action_140
action_131 _ = happyReduce_18

action_132 (32) = happyShift action_20
action_132 (33) = happyShift action_139
action_132 (50) = happyShift action_22
action_132 (51) = happyShift action_23
action_132 (52) = happyShift action_24
action_132 (60) = happyShift action_25
action_132 (61) = happyShift action_26
action_132 (65) = happyShift action_27
action_132 (66) = happyShift action_28
action_132 (19) = happyGoto action_135
action_132 (20) = happyGoto action_136
action_132 (21) = happyGoto action_137
action_132 (22) = happyGoto action_138
action_132 _ = happyFail

action_133 (26) = happyShift action_54
action_133 (27) = happyShift action_55
action_133 (28) = happyShift action_56
action_133 (29) = happyShift action_57
action_133 (30) = happyShift action_58
action_133 (31) = happyShift action_59
action_133 (39) = happyShift action_60
action_133 (40) = happyShift action_61
action_133 (41) = happyShift action_62
action_133 (42) = happyShift action_63
action_133 (43) = happyShift action_64
action_133 (44) = happyShift action_65
action_133 (45) = happyShift action_66
action_133 (46) = happyShift action_67
action_133 (47) = happyShift action_134
action_133 _ = happyFail

action_134 (32) = happyShift action_20
action_134 (33) = happyShift action_139
action_134 (50) = happyShift action_22
action_134 (51) = happyShift action_23
action_134 (52) = happyShift action_24
action_134 (60) = happyShift action_25
action_134 (61) = happyShift action_26
action_134 (65) = happyShift action_27
action_134 (66) = happyShift action_28
action_134 (19) = happyGoto action_135
action_134 (20) = happyGoto action_145
action_134 (21) = happyGoto action_137
action_134 (22) = happyGoto action_138
action_134 _ = happyFail

action_135 (25) = happyShift action_144
action_135 (26) = happyShift action_54
action_135 (27) = happyShift action_55
action_135 (28) = happyShift action_56
action_135 (29) = happyShift action_57
action_135 (30) = happyShift action_58
action_135 (31) = happyShift action_59
action_135 (39) = happyShift action_60
action_135 (40) = happyShift action_61
action_135 (41) = happyShift action_62
action_135 (42) = happyShift action_63
action_135 (43) = happyShift action_64
action_135 (44) = happyShift action_65
action_135 (45) = happyShift action_66
action_135 (46) = happyShift action_67
action_135 _ = happyFail

action_136 _ = happyReduce_28

action_137 (43) = happyShift action_143
action_137 _ = happyReduce_53

action_138 _ = happyReduce_56

action_139 (32) = happyShift action_20
action_139 (33) = happyShift action_21
action_139 (50) = happyShift action_22
action_139 (51) = happyShift action_23
action_139 (52) = happyShift action_24
action_139 (60) = happyShift action_25
action_139 (61) = happyShift action_26
action_139 (65) = happyShift action_142
action_139 (66) = happyShift action_28
action_139 (19) = happyGoto action_52
action_139 _ = happyFail

action_140 (32) = happyShift action_20
action_140 (33) = happyShift action_21
action_140 (50) = happyShift action_22
action_140 (51) = happyShift action_23
action_140 (52) = happyShift action_24
action_140 (60) = happyShift action_25
action_140 (61) = happyShift action_26
action_140 (65) = happyShift action_27
action_140 (66) = happyShift action_28
action_140 (19) = happyGoto action_141
action_140 _ = happyFail

action_141 (26) = happyShift action_54
action_141 (27) = happyShift action_55
action_141 (28) = happyShift action_56
action_141 (29) = happyShift action_57
action_141 (30) = happyShift action_58
action_141 (31) = happyShift action_59
action_141 (39) = happyShift action_60
action_141 (40) = happyShift action_61
action_141 (41) = happyShift action_62
action_141 (42) = happyShift action_63
action_141 (43) = happyShift action_64
action_141 (44) = happyShift action_65
action_141 (45) = happyShift action_66
action_141 (46) = happyShift action_67
action_141 _ = happyReduce_19

action_142 (49) = happyShift action_149
action_142 _ = happyReduce_50

action_143 (33) = happyShift action_147
action_143 (22) = happyGoto action_148
action_143 _ = happyFail

action_144 (33) = happyShift action_147
action_144 (21) = happyGoto action_146
action_144 (22) = happyGoto action_138
action_144 _ = happyFail

action_145 _ = happyReduce_29

action_146 (41) = happyShift action_152
action_146 (43) = happyShift action_143
action_146 _ = happyReduce_54

action_147 (65) = happyShift action_151
action_147 _ = happyFail

action_148 _ = happyReduce_57

action_149 (30) = happyShift action_150
action_149 _ = happyFail

action_150 (32) = happyShift action_20
action_150 (33) = happyShift action_21
action_150 (50) = happyShift action_22
action_150 (51) = happyShift action_23
action_150 (52) = happyShift action_24
action_150 (60) = happyShift action_25
action_150 (61) = happyShift action_26
action_150 (65) = happyShift action_27
action_150 (66) = happyShift action_28
action_150 (19) = happyGoto action_154
action_150 _ = happyFail

action_151 (49) = happyShift action_149
action_151 _ = happyFail

action_152 (32) = happyShift action_20
action_152 (33) = happyShift action_139
action_152 (50) = happyShift action_22
action_152 (51) = happyShift action_23
action_152 (52) = happyShift action_24
action_152 (60) = happyShift action_25
action_152 (61) = happyShift action_26
action_152 (65) = happyShift action_27
action_152 (66) = happyShift action_28
action_152 (19) = happyGoto action_135
action_152 (20) = happyGoto action_153
action_152 (21) = happyGoto action_137
action_152 (22) = happyGoto action_138
action_152 _ = happyFail

action_153 _ = happyReduce_55

action_154 (26) = happyShift action_54
action_154 (27) = happyShift action_55
action_154 (28) = happyShift action_56
action_154 (29) = happyShift action_57
action_154 (30) = happyShift action_58
action_154 (31) = happyShift action_59
action_154 (35) = happyShift action_155
action_154 (39) = happyShift action_60
action_154 (40) = happyShift action_61
action_154 (41) = happyShift action_62
action_154 (42) = happyShift action_63
action_154 (43) = happyShift action_64
action_154 (44) = happyShift action_65
action_154 (45) = happyShift action_66
action_154 (46) = happyShift action_67
action_154 _ = happyFail

action_155 _ = happyReduce_58

happyReduce_1 = happyReduce 6 4 happyReduction_1
happyReduction_1 ((HappyAbsSyn15  happy_var_6) `HappyStk`
	(HappyAbsSyn11  happy_var_5) `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	happyRest)
	 = HappyAbsSyn4
		 (PrismModel happy_var_5 happy_var_6
	) `HappyStk` happyRest

happyReduce_2 = happySpecReduce_0  5 happyReduction_2
happyReduction_2  =  HappyAbsSyn5
		 (
	)

happyReduce_3 = happySpecReduce_3  5 happyReduction_3
happyReduction_3 _
	_
	_
	 =  HappyAbsSyn5
		 (
	)

happyReduce_4 = happyReduce 4 6 happyReduction_4
happyReduction_4 (_ `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	happyRest)
	 = HappyAbsSyn6
		 (
	) `HappyStk` happyRest

happyReduce_5 = happySpecReduce_0  7 happyReduction_5
happyReduction_5  =  HappyAbsSyn7
		 (
	)

happyReduce_6 = happySpecReduce_3  7 happyReduction_6
happyReduction_6 _
	_
	_
	 =  HappyAbsSyn7
		 (
	)

happyReduce_7 = happyReduce 6 8 happyReduction_7
happyReduction_7 (_ `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	happyRest)
	 = HappyAbsSyn8
		 (
	) `HappyStk` happyRest

happyReduce_8 = happySpecReduce_0  9 happyReduction_8
happyReduction_8  =  HappyAbsSyn9
		 (
	)

happyReduce_9 = happySpecReduce_3  9 happyReduction_9
happyReduction_9 _
	_
	_
	 =  HappyAbsSyn9
		 (
	)

happyReduce_10 = happyReduce 5 10 happyReduction_10
happyReduction_10 (_ `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	happyRest)
	 = HappyAbsSyn10
		 (
	) `HappyStk` happyRest

happyReduce_11 = happyReduce 5 10 happyReduction_11
happyReduction_11 (_ `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	happyRest)
	 = HappyAbsSyn10
		 (
	) `HappyStk` happyRest

happyReduce_12 = happyReduce 5 10 happyReduction_12
happyReduction_12 (_ `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	happyRest)
	 = HappyAbsSyn10
		 (
	) `HappyStk` happyRest

happyReduce_13 = happySpecReduce_0  11 happyReduction_13
happyReduction_13  =  HappyAbsSyn11
		 ([]
	)

happyReduce_14 = happySpecReduce_3  11 happyReduction_14
happyReduction_14 (HappyAbsSyn11  happy_var_3)
	_
	(HappyAbsSyn12  happy_var_1)
	 =  HappyAbsSyn11
		 (happy_var_1 : happy_var_3
	)
happyReduction_14 _ _ _  = notHappyAtAll 

happyReduce_15 = happySpecReduce_2  12 happyReduction_15
happyReduction_15 (HappyAbsSyn14  happy_var_2)
	_
	 =  HappyAbsSyn12
		 (happy_var_2
	)
happyReduction_15 _ _  = notHappyAtAll 

happyReduce_16 = happySpecReduce_0  13 happyReduction_16
happyReduction_16  =  HappyAbsSyn13
		 ([]
	)

happyReduce_17 = happySpecReduce_3  13 happyReduction_17
happyReduction_17 (HappyAbsSyn13  happy_var_3)
	_
	(HappyAbsSyn14  happy_var_1)
	 =  HappyAbsSyn13
		 (happy_var_1 : happy_var_3
	)
happyReduction_17 _ _ _  = notHappyAtAll 

happyReduce_18 = happyReduce 7 14 happyReduction_18
happyReduction_18 (_ `HappyStk`
	(HappyAbsSyn19  happy_var_6) `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn19  happy_var_4) `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	(HappyTerminal (TokenString happy_var_1)) `HappyStk`
	happyRest)
	 = HappyAbsSyn14
		 (IntRange (happy_var_1, read (evalExpr [] [] happy_var_4), 
                                                                                              read (evalExpr [] [] happy_var_6), 
                                                                                              read (evalExpr [] [] happy_var_4))
	) `HappyStk` happyRest

happyReduce_19 = happyReduce 9 14 happyReduction_19
happyReduction_19 ((HappyAbsSyn19  happy_var_9) `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn19  happy_var_6) `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn19  happy_var_4) `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	(HappyTerminal (TokenString happy_var_1)) `HappyStk`
	happyRest)
	 = HappyAbsSyn14
		 (IntRange (happy_var_1, read (evalExpr [] [] happy_var_4), 
                                                                                              read (evalExpr [] [] happy_var_6), 
                                                                                              read (evalExpr [] [] happy_var_9))
	) `HappyStk` happyRest

happyReduce_20 = happySpecReduce_3  14 happyReduction_20
happyReduction_20 _
	_
	(HappyTerminal (TokenString happy_var_1))
	 =  HappyAbsSyn14
		 (Boolean (happy_var_1, False)
	)
happyReduction_20 _ _ _  = notHappyAtAll 

happyReduce_21 = happyReduce 5 14 happyReduction_21
happyReduction_21 (_ `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	(HappyTerminal (TokenString happy_var_1)) `HappyStk`
	happyRest)
	 = HappyAbsSyn14
		 (Boolean (happy_var_1, True)
	) `HappyStk` happyRest

happyReduce_22 = happyReduce 5 14 happyReduction_22
happyReduction_22 (_ `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	(HappyTerminal (TokenString happy_var_1)) `HappyStk`
	happyRest)
	 = HappyAbsSyn14
		 (Boolean (happy_var_1, False)
	) `HappyStk` happyRest

happyReduce_23 = happySpecReduce_1  15 happyReduction_23
happyReduction_23 (HappyAbsSyn16  happy_var_1)
	 =  HappyAbsSyn15
		 ([happy_var_1]
	)
happyReduction_23 _  = notHappyAtAll 

happyReduce_24 = happySpecReduce_2  15 happyReduction_24
happyReduction_24 (HappyAbsSyn15  happy_var_2)
	(HappyAbsSyn16  happy_var_1)
	 =  HappyAbsSyn15
		 (happy_var_1 : happy_var_2
	)
happyReduction_24 _ _  = notHappyAtAll 

happyReduce_25 = happyReduce 5 16 happyReduction_25
happyReduction_25 (_ `HappyStk`
	(HappyAbsSyn17  happy_var_4) `HappyStk`
	(HappyAbsSyn13  happy_var_3) `HappyStk`
	(HappyTerminal (TokenString happy_var_2)) `HappyStk`
	_ `HappyStk`
	happyRest)
	 = HappyAbsSyn16
		 (Module happy_var_2 happy_var_3 happy_var_4
	) `HappyStk` happyRest

happyReduce_26 = happySpecReduce_0  17 happyReduction_26
happyReduction_26  =  HappyAbsSyn17
		 ([]
	)

happyReduce_27 = happySpecReduce_3  17 happyReduction_27
happyReduction_27 (HappyAbsSyn17  happy_var_3)
	_
	(HappyAbsSyn18  happy_var_1)
	 =  HappyAbsSyn17
		 (happy_var_1 : happy_var_3
	)
happyReduction_27 _ _ _  = notHappyAtAll 

happyReduce_28 = happyReduce 5 18 happyReduction_28
happyReduction_28 ((HappyAbsSyn20  happy_var_5) `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn19  happy_var_3) `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	happyRest)
	 = HappyAbsSyn18
		 ((happy_var_3, "tau", happy_var_5)
	) `HappyStk` happyRest

happyReduce_29 = happyReduce 6 18 happyReduction_29
happyReduction_29 ((HappyAbsSyn20  happy_var_6) `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn19  happy_var_4) `HappyStk`
	_ `HappyStk`
	(HappyTerminal (TokenString happy_var_2)) `HappyStk`
	_ `HappyStk`
	happyRest)
	 = HappyAbsSyn18
		 ((happy_var_4, happy_var_2, happy_var_6)
	) `HappyStk` happyRest

happyReduce_30 = happySpecReduce_3  19 happyReduction_30
happyReduction_30 (HappyAbsSyn19  happy_var_3)
	_
	(HappyAbsSyn19  happy_var_1)
	 =  HappyAbsSyn19
		 (Function "multiply" [happy_var_1, happy_var_3]
	)
happyReduction_30 _ _ _  = notHappyAtAll 

happyReduce_31 = happySpecReduce_3  19 happyReduction_31
happyReduction_31 (HappyAbsSyn19  happy_var_3)
	_
	(HappyAbsSyn19  happy_var_1)
	 =  HappyAbsSyn19
		 (Function "divide" [happy_var_1, happy_var_3]
	)
happyReduction_31 _ _ _  = notHappyAtAll 

happyReduce_32 = happySpecReduce_3  19 happyReduction_32
happyReduction_32 (HappyAbsSyn19  happy_var_3)
	_
	(HappyAbsSyn19  happy_var_1)
	 =  HappyAbsSyn19
		 (Function "plus" [happy_var_1, happy_var_3]
	)
happyReduction_32 _ _ _  = notHappyAtAll 

happyReduce_33 = happySpecReduce_3  19 happyReduction_33
happyReduction_33 (HappyAbsSyn19  happy_var_3)
	_
	(HappyAbsSyn19  happy_var_1)
	 =  HappyAbsSyn19
		 (Function "minus" [happy_var_1, happy_var_3]
	)
happyReduction_33 _ _ _  = notHappyAtAll 

happyReduce_34 = happySpecReduce_3  19 happyReduction_34
happyReduction_34 (HappyAbsSyn19  happy_var_3)
	_
	(HappyAbsSyn19  happy_var_1)
	 =  HappyAbsSyn19
		 (Function "leq" [happy_var_1, happy_var_3]
	)
happyReduction_34 _ _ _  = notHappyAtAll 

happyReduce_35 = happySpecReduce_3  19 happyReduction_35
happyReduction_35 (HappyAbsSyn19  happy_var_3)
	_
	(HappyAbsSyn19  happy_var_1)
	 =  HappyAbsSyn19
		 (Function "lt" [happy_var_1, happy_var_3]
	)
happyReduction_35 _ _ _  = notHappyAtAll 

happyReduce_36 = happySpecReduce_3  19 happyReduction_36
happyReduction_36 (HappyAbsSyn19  happy_var_3)
	_
	(HappyAbsSyn19  happy_var_1)
	 =  HappyAbsSyn19
		 (Function "gt" [happy_var_1, happy_var_3]
	)
happyReduction_36 _ _ _  = notHappyAtAll 

happyReduce_37 = happySpecReduce_3  19 happyReduction_37
happyReduction_37 (HappyAbsSyn19  happy_var_3)
	_
	(HappyAbsSyn19  happy_var_1)
	 =  HappyAbsSyn19
		 (Function "geq" [happy_var_1, happy_var_3]
	)
happyReduction_37 _ _ _  = notHappyAtAll 

happyReduce_38 = happySpecReduce_3  19 happyReduction_38
happyReduction_38 (HappyAbsSyn19  happy_var_3)
	_
	(HappyAbsSyn19  happy_var_1)
	 =  HappyAbsSyn19
		 (Function "eq" [happy_var_1, happy_var_3]
	)
happyReduction_38 _ _ _  = notHappyAtAll 

happyReduce_39 = happySpecReduce_3  19 happyReduction_39
happyReduction_39 (HappyAbsSyn19  happy_var_3)
	_
	(HappyAbsSyn19  happy_var_1)
	 =  HappyAbsSyn19
		 (Function "not" [Function "eq" [happy_var_1, happy_var_3]]
	)
happyReduction_39 _ _ _  = notHappyAtAll 

happyReduce_40 = happySpecReduce_2  19 happyReduction_40
happyReduction_40 (HappyAbsSyn19  happy_var_2)
	_
	 =  HappyAbsSyn19
		 (Function "not" [happy_var_2]
	)
happyReduction_40 _ _  = notHappyAtAll 

happyReduce_41 = happySpecReduce_3  19 happyReduction_41
happyReduction_41 (HappyAbsSyn19  happy_var_3)
	_
	(HappyAbsSyn19  happy_var_1)
	 =  HappyAbsSyn19
		 (Function "and" [happy_var_1, happy_var_3]
	)
happyReduction_41 _ _ _  = notHappyAtAll 

happyReduce_42 = happySpecReduce_3  19 happyReduction_42
happyReduction_42 (HappyAbsSyn19  happy_var_3)
	_
	(HappyAbsSyn19  happy_var_1)
	 =  HappyAbsSyn19
		 (Function "or" [happy_var_1, happy_var_3]
	)
happyReduction_42 _ _ _  = notHappyAtAll 

happyReduce_43 = happySpecReduce_3  19 happyReduction_43
happyReduction_43 (HappyAbsSyn19  happy_var_3)
	_
	(HappyAbsSyn19  happy_var_1)
	 =  HappyAbsSyn19
		 (Function "or" [happy_var_3, Function "not" [happy_var_1]]
	)
happyReduction_43 _ _ _  = notHappyAtAll 

happyReduce_44 = happyReduce 5 19 happyReduction_44
happyReduction_44 ((HappyAbsSyn19  happy_var_5) `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn19  happy_var_3) `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn19  happy_var_1) `HappyStk`
	happyRest)
	 = HappyAbsSyn19
		 (Function "ifthenelse" [happy_var_1, happy_var_3, happy_var_5]
	) `HappyStk` happyRest

happyReduce_45 = happyReduce 6 19 happyReduction_45
happyReduction_45 (_ `HappyStk`
	(HappyAbsSyn19  happy_var_5) `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn19  happy_var_3) `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	happyRest)
	 = HappyAbsSyn19
		 (Function "min" [happy_var_3, happy_var_5]
	) `HappyStk` happyRest

happyReduce_46 = happyReduce 6 19 happyReduction_46
happyReduction_46 (_ `HappyStk`
	(HappyAbsSyn19  happy_var_5) `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn19  happy_var_3) `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	happyRest)
	 = HappyAbsSyn19
		 (Function "max" [happy_var_3, happy_var_5]
	) `HappyStk` happyRest

happyReduce_47 = happyReduce 6 19 happyReduction_47
happyReduction_47 (_ `HappyStk`
	(HappyAbsSyn19  happy_var_5) `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn19  happy_var_3) `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	happyRest)
	 = HappyAbsSyn19
		 (Function "mod" [happy_var_3, happy_var_5]
	) `HappyStk` happyRest

happyReduce_48 = happySpecReduce_1  19 happyReduction_48
happyReduction_48 _
	 =  HappyAbsSyn19
		 (Variable "T"
	)

happyReduce_49 = happySpecReduce_1  19 happyReduction_49
happyReduction_49 _
	 =  HappyAbsSyn19
		 (Variable "F"
	)

happyReduce_50 = happySpecReduce_1  19 happyReduction_50
happyReduction_50 (HappyTerminal (TokenString happy_var_1))
	 =  HappyAbsSyn19
		 (Variable happy_var_1
	)
happyReduction_50 _  = notHappyAtAll 

happyReduce_51 = happySpecReduce_1  19 happyReduction_51
happyReduction_51 (HappyTerminal (TokenNumber happy_var_1))
	 =  HappyAbsSyn19
		 (Variable happy_var_1
	)
happyReduction_51 _  = notHappyAtAll 

happyReduce_52 = happySpecReduce_3  19 happyReduction_52
happyReduction_52 _
	(HappyAbsSyn19  happy_var_2)
	_
	 =  HappyAbsSyn19
		 (happy_var_2
	)
happyReduction_52 _ _ _  = notHappyAtAll 

happyReduce_53 = happySpecReduce_1  20 happyReduction_53
happyReduction_53 (HappyAbsSyn21  happy_var_1)
	 =  HappyAbsSyn20
		 ([(Variable "1", happy_var_1)]
	)
happyReduction_53 _  = notHappyAtAll 

happyReduce_54 = happySpecReduce_3  20 happyReduction_54
happyReduction_54 (HappyAbsSyn21  happy_var_3)
	_
	(HappyAbsSyn19  happy_var_1)
	 =  HappyAbsSyn20
		 ([(happy_var_1, happy_var_3)]
	)
happyReduction_54 _ _ _  = notHappyAtAll 

happyReduce_55 = happyReduce 5 20 happyReduction_55
happyReduction_55 ((HappyAbsSyn20  happy_var_5) `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn21  happy_var_3) `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn19  happy_var_1) `HappyStk`
	happyRest)
	 = HappyAbsSyn20
		 ((happy_var_1, happy_var_3) : happy_var_5
	) `HappyStk` happyRest

happyReduce_56 = happySpecReduce_1  21 happyReduction_56
happyReduction_56 (HappyAbsSyn22  happy_var_1)
	 =  HappyAbsSyn21
		 ([happy_var_1]
	)
happyReduction_56 _  = notHappyAtAll 

happyReduce_57 = happySpecReduce_3  21 happyReduction_57
happyReduction_57 (HappyAbsSyn22  happy_var_3)
	_
	(HappyAbsSyn21  happy_var_1)
	 =  HappyAbsSyn21
		 (happy_var_3 : happy_var_1
	)
happyReduction_57 _ _ _  = notHappyAtAll 

happyReduce_58 = happyReduce 6 22 happyReduction_58
happyReduction_58 (_ `HappyStk`
	(HappyAbsSyn19  happy_var_5) `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	(HappyTerminal (TokenString happy_var_2)) `HappyStk`
	_ `HappyStk`
	happyRest)
	 = HappyAbsSyn22
		 ((happy_var_2, happy_var_5)
	) `HappyStk` happyRest

happyNewToken action sts stk [] =
	action 67 67 notHappyAtAll (HappyState action) sts stk []

happyNewToken action sts stk (tk:tks) =
	let cont i = action i i tk (HappyState action) sts stk tks in
	case tk of {
	TokenComma -> cont 23;
	TokenSemiColon -> cont 24;
	TokenColon -> cont 25;
	TokenGreater -> cont 26;
	TokenSmaller -> cont 27;
	TokenSmallerEqual -> cont 28;
	TokenGreaterEqual -> cont 29;
	TokenEqual -> cont 30;
	TokenNotEqual -> cont 31;
	TokenNot -> cont 32;
	TokenOB -> cont 33;
	TokenQuotation -> cont 34;
	TokenCB -> cont 35;
	TokenRange -> cont 36;
	TokenOSB -> cont 37;
	TokenCSB -> cont 38;
	TokenMultiply -> cont 39;
	TokenDivide -> cont 40;
	TokenPlus -> cont 41;
	TokenMinus -> cont 42;
	TokenAnd -> cont 43;
	TokenOr -> cont 44;
	TokenIf -> cont 45;
	TokenImplies -> cont 46;
	TokenArrow -> cont 47;
	TokenMDP -> cont 48;
	TokenApos -> cont 49;
	TokenMinimum -> cont 50;
	TokenMaximum -> cont 51;
	TokenMod -> cont 52;
	TokenInt -> cont 53;
	TokenInit -> cont 54;
	TokenModule -> cont 55;
	TokenFormula -> cont 56;
	TokenLabel -> cont 57;
	TokenBool -> cont 58;
	TokenDouble -> cont 59;
	TokenTrue -> cont 60;
	TokenFalse -> cont 61;
	TokenGlobal -> cont 62;
	TokenConstant -> cont 63;
	TokenEndModule -> cont 64;
	TokenString happy_dollar_dollar -> cont 65;
	TokenNumber happy_dollar_dollar -> cont 66;
	_ -> happyError' (tk:tks)
	}

happyError_ 67 tk tks = happyError' tks
happyError_ _ tk tks = happyError' (tk:tks)

newtype HappyIdentity a = HappyIdentity a
happyIdentity = HappyIdentity
happyRunIdentity (HappyIdentity a) = a

instance Monad HappyIdentity where
    return = HappyIdentity
    (HappyIdentity p) >>= q = q p

happyThen :: () => HappyIdentity a -> (a -> HappyIdentity b) -> HappyIdentity b
happyThen = (>>=)
happyReturn :: () => a -> HappyIdentity a
happyReturn = (return)
happyThen1 m k tks = (>>=) m (\a -> k a tks)
happyReturn1 :: () => a -> b -> HappyIdentity a
happyReturn1 = \a tks -> (return) a
happyError' :: () => [(Token)] -> HappyIdentity a
happyError' = HappyIdentity . parseError

prismParse tks = happyRunIdentity happySomeParser where
  happySomeParser = happyThen (happyParse action_0 tks) (\x -> case x of {HappyAbsSyn4 z -> happyReturn z; _other -> notHappyAtAll })

happySeq = happyDontSeq


parseError :: [Token] -> a 
parseError t = error ("Error: Parser did not expect token " ++ show t)


data Token = TokenString String
           | TokenNumber String
           | TokenOB 
           | TokenCB 
           | TokenOSB 
           | TokenRange
           | TokenCSB 
           | TokenBool
           | TokenDouble
           | TokenAnd
           | TokenPlus
           | TokenMinus
           | TokenMultiply
           | TokenDivide
           | TokenQuotation
           | TokenArrow
           | TokenMDP
           | TokenModule
           | TokenTrue
           | TokenFalse
           | TokenEqual
           | TokenConstant
           | TokenNotEqual
           | TokenGreaterEqual
           | TokenSmallerEqual
           | TokenGreater
           | TokenGlobal
           | TokenComma
           | TokenIf
           | TokenSmaller
           | TokenEndModule
           | TokenNot
           | TokenColon
           | TokenInt
           | TokenMod
           | TokenOr
           | TokenMinimum
           | TokenMaximum
           | TokenImplies
           | TokenSemiColon
           | TokenFormula
           | TokenLabel
           | TokenInit
           | TokenApos
           deriving Show 

prismLexer :: String -> [Token] 
prismLexer [] = [] 
prismLexer ('.':'.':cs) = TokenRange : prismLexer cs 
prismLexer ('i':'n':'i':'t':cs) = TokenInit : prismLexer cs
prismLexer ('m':'d':'p':cs) = TokenMDP : prismLexer cs
prismLexer ('i':'n':'t':cs) = TokenInt : prismLexer cs
prismLexer ('d':'o':'u':'b':'l':'e':cs) = TokenDouble : prismLexer cs
prismLexer ('g':'l':'o':'b':'a':'l':cs) = TokenGlobal : prismLexer cs
prismLexer ('m':'o':'d':'u':'l':'e':cs) = TokenModule : prismLexer cs
prismLexer ('l':'a':'b':'e':'l':cs) = TokenLabel : prismLexer cs
prismLexer ('c':'o':'n':'s':'t':cs) = TokenConstant : prismLexer cs
prismLexer ('t':'r':'u':'e':cs) = TokenTrue : prismLexer cs
prismLexer ('m':'i':'n':cs) = TokenMinimum : prismLexer cs
prismLexer ('m':'a':'x':cs) = TokenMaximum : prismLexer cs
prismLexer ('m':'o':'d':cs) = TokenMod : prismLexer cs
prismLexer ('f':'a':'l':'s':'e':cs) = TokenFalse : prismLexer cs
prismLexer ('b':'o':'o':'l':cs) = TokenBool : prismLexer cs
prismLexer ('e':'n':'d':'m':'o':'d':'u':'l':'e':cs) = TokenEndModule : prismLexer cs
prismLexer ('f':'o':'r':'m':'u':'l':'a':cs) = TokenFormula : prismLexer cs
prismLexer (c:cs) 
      | isSpace           c = prismLexer cs 
      | (\x -> isAlpha x) c = lexString (c:cs)
      | isDigit           c = lexDigit (c:cs)
prismLexer ('-':'>':cs) = TokenArrow : prismLexer cs 
prismLexer ('=':'>':cs) = TokenImplies : prismLexer cs 
prismLexer ('!':'=':cs) = TokenNotEqual : prismLexer cs 
prismLexer ('!':cs) = TokenNot : prismLexer cs 
prismLexer (',':cs) = TokenComma : prismLexer cs 
prismLexer ('\'':cs) = TokenApos : prismLexer cs 
prismLexer ('<':'=':cs) = TokenSmallerEqual : prismLexer cs 
prismLexer ('>':'=':cs) = TokenGreaterEqual : prismLexer cs 
prismLexer ('<':cs) = TokenSmaller : prismLexer cs 
prismLexer ('>':cs) = TokenGreater : prismLexer cs 
prismLexer ('=':cs) = TokenEqual : prismLexer cs 
prismLexer ('*':cs) = TokenMultiply : prismLexer cs 
prismLexer ('/':cs) = TokenDivide : prismLexer cs 
prismLexer ('-':cs) = TokenMinus : prismLexer cs 
prismLexer ('+':cs) = TokenPlus : prismLexer cs 
prismLexer ('?':cs) = TokenIf : prismLexer cs 
prismLexer (';':cs) = TokenSemiColon : prismLexer cs 
prismLexer ('&':cs) = TokenAnd : prismLexer cs 
prismLexer ('|':cs) = TokenOr : prismLexer cs 
prismLexer (':':cs) = TokenColon : prismLexer cs 
prismLexer ('"':cs) = TokenQuotation : prismLexer cs 
prismLexer ('(':cs) = TokenOB : prismLexer cs 
prismLexer (')':cs) = TokenCB : prismLexer cs 
prismLexer ('[':cs) = TokenOSB : prismLexer cs 
prismLexer (']':cs) = TokenCSB : prismLexer cs 
prismLexer s = error("Error: Lexer could not deal with character " ++ [head s])

lexString cs = TokenString var : prismLexer rest
  where
    (var,rest) = getString cs

getString [] = ("","")
getString ('.':'.':cs) = ("", '.':'.':cs)
getString (c:cs) | elem c " ',()&=*.</>+:-!?;|\"[]" = ("", c:cs)
                 | otherwise = (str,rest)
  where
    (s,r) = getString cs
    str   = c:s
    rest  = r


lexDigit cs = (TokenNumber num) : prismLexer rest
  where
    (num,rest) = getNumber cs

getNumber [] = ("","")
getNumber ('.':'.':cs) = ("", '.':'.':cs)
getNumber (c:cs)       | elem c " ',()&=<*/>?+:-!;|\"[]" = ("", c:cs)
                       | otherwise = (num,rest)
  where
    (n,r) = getNumber cs
    num   = c:n
    rest  = r
{-# LINE 1 "templates/GenericTemplate.hs" #-}
{-# LINE 1 "templates/GenericTemplate.hs" #-}
{-# LINE 1 "<built-in>" #-}
{-# LINE 1 "<command-line>" #-}
{-# LINE 1 "templates/GenericTemplate.hs" #-}
-- Id: GenericTemplate.hs,v 1.26 2005/01/14 14:47:22 simonmar Exp 

{-# LINE 30 "templates/GenericTemplate.hs" #-}








{-# LINE 51 "templates/GenericTemplate.hs" #-}

{-# LINE 61 "templates/GenericTemplate.hs" #-}

{-# LINE 70 "templates/GenericTemplate.hs" #-}

infixr 9 `HappyStk`
data HappyStk a = HappyStk a (HappyStk a)

-----------------------------------------------------------------------------
-- starting the parse

happyParse start_state = happyNewToken start_state notHappyAtAll notHappyAtAll

-----------------------------------------------------------------------------
-- Accepting the parse

-- If the current token is (1), it means we've just accepted a partial
-- parse (a %partial parser).  We must ignore the saved token on the top of
-- the stack in this case.
happyAccept (1) tk st sts (_ `HappyStk` ans `HappyStk` _) =
	happyReturn1 ans
happyAccept j tk st sts (HappyStk ans _) = 
	 (happyReturn1 ans)

-----------------------------------------------------------------------------
-- Arrays only: do the next action

{-# LINE 148 "templates/GenericTemplate.hs" #-}

-----------------------------------------------------------------------------
-- HappyState data type (not arrays)



newtype HappyState b c = HappyState
        (Int ->                    -- token number
         Int ->                    -- token number (yes, again)
         b ->                           -- token semantic value
         HappyState b c ->              -- current state
         [HappyState b c] ->            -- state stack
         c)



-----------------------------------------------------------------------------
-- Shifting a token

happyShift new_state (1) tk st sts stk@(x `HappyStk` _) =
     let (i) = (case x of { HappyErrorToken (i) -> i }) in
--     trace "shifting the error token" $
     new_state i i tk (HappyState (new_state)) ((st):(sts)) (stk)

happyShift new_state i tk st sts stk =
     happyNewToken new_state ((st):(sts)) ((HappyTerminal (tk))`HappyStk`stk)

-- happyReduce is specialised for the common cases.

happySpecReduce_0 i fn (1) tk st sts stk
     = happyFail (1) tk st sts stk
happySpecReduce_0 nt fn j tk st@((HappyState (action))) sts stk
     = action nt j tk st ((st):(sts)) (fn `HappyStk` stk)

happySpecReduce_1 i fn (1) tk st sts stk
     = happyFail (1) tk st sts stk
happySpecReduce_1 nt fn j tk _ sts@(((st@(HappyState (action))):(_))) (v1`HappyStk`stk')
     = let r = fn v1 in
       happySeq r (action nt j tk st sts (r `HappyStk` stk'))

happySpecReduce_2 i fn (1) tk st sts stk
     = happyFail (1) tk st sts stk
happySpecReduce_2 nt fn j tk _ ((_):(sts@(((st@(HappyState (action))):(_))))) (v1`HappyStk`v2`HappyStk`stk')
     = let r = fn v1 v2 in
       happySeq r (action nt j tk st sts (r `HappyStk` stk'))

happySpecReduce_3 i fn (1) tk st sts stk
     = happyFail (1) tk st sts stk
happySpecReduce_3 nt fn j tk _ ((_):(((_):(sts@(((st@(HappyState (action))):(_))))))) (v1`HappyStk`v2`HappyStk`v3`HappyStk`stk')
     = let r = fn v1 v2 v3 in
       happySeq r (action nt j tk st sts (r `HappyStk` stk'))

happyReduce k i fn (1) tk st sts stk
     = happyFail (1) tk st sts stk
happyReduce k nt fn j tk st sts stk
     = case happyDrop (k - ((1) :: Int)) sts of
	 sts1@(((st1@(HappyState (action))):(_))) ->
        	let r = fn stk in  -- it doesn't hurt to always seq here...
       		happyDoSeq r (action nt j tk st1 sts1 r)

happyMonadReduce k nt fn (1) tk st sts stk
     = happyFail (1) tk st sts stk
happyMonadReduce k nt fn j tk st sts stk =
        happyThen1 (fn stk tk) (\r -> action nt j tk st1 sts1 (r `HappyStk` drop_stk))
       where (sts1@(((st1@(HappyState (action))):(_)))) = happyDrop k ((st):(sts))
             drop_stk = happyDropStk k stk

happyMonad2Reduce k nt fn (1) tk st sts stk
     = happyFail (1) tk st sts stk
happyMonad2Reduce k nt fn j tk st sts stk =
       happyThen1 (fn stk tk) (\r -> happyNewToken new_state sts1 (r `HappyStk` drop_stk))
       where (sts1@(((st1@(HappyState (action))):(_)))) = happyDrop k ((st):(sts))
             drop_stk = happyDropStk k stk





             new_state = action


happyDrop (0) l = l
happyDrop n ((_):(t)) = happyDrop (n - ((1) :: Int)) t

happyDropStk (0) l = l
happyDropStk n (x `HappyStk` xs) = happyDropStk (n - ((1)::Int)) xs

-----------------------------------------------------------------------------
-- Moving to a new state after a reduction

{-# LINE 246 "templates/GenericTemplate.hs" #-}
happyGoto action j tk st = action j j tk (HappyState action)


-----------------------------------------------------------------------------
-- Error recovery ((1) is the error token)

-- parse error if we are in recovery and we fail again
happyFail (1) tk old_st _ stk@(x `HappyStk` _) =
     let (i) = (case x of { HappyErrorToken (i) -> i }) in
--	trace "failing" $ 
        happyError_ i tk

{-  We don't need state discarding for our restricted implementation of
    "error".  In fact, it can cause some bogus parses, so I've disabled it
    for now --SDM

-- discard a state
happyFail  (1) tk old_st (((HappyState (action))):(sts)) 
						(saved_tok `HappyStk` _ `HappyStk` stk) =
--	trace ("discarding state, depth " ++ show (length stk))  $
	action (1) (1) tk (HappyState (action)) sts ((saved_tok`HappyStk`stk))
-}

-- Enter error recovery: generate an error token,
--                       save the old token and carry on.
happyFail  i tk (HappyState (action)) sts stk =
--      trace "entering error recovery" $
	action (1) (1) tk (HappyState (action)) sts ( (HappyErrorToken (i)) `HappyStk` stk)

-- Internal happy errors:

notHappyAtAll :: a
notHappyAtAll = error "Internal Happy error\n"

-----------------------------------------------------------------------------
-- Hack to get the typechecker to accept our action functions







-----------------------------------------------------------------------------
-- Seq-ing.  If the --strict flag is given, then Happy emits 
--	happySeq = happyDoSeq
-- otherwise it emits
-- 	happySeq = happyDontSeq

happyDoSeq, happyDontSeq :: a -> b -> b
happyDoSeq   a b = a `seq` b
happyDontSeq a b = b

-----------------------------------------------------------------------------
-- Don't inline any functions from the template.  GHC has a nasty habit
-- of deciding to inline happyGoto everywhere, which increases the size of
-- the generated parser quite a bit.

{-# LINE 312 "templates/GenericTemplate.hs" #-}
{-# NOINLINE happyShift #-}
{-# NOINLINE happySpecReduce_0 #-}
{-# NOINLINE happySpecReduce_1 #-}
{-# NOINLINE happySpecReduce_2 #-}
{-# NOINLINE happySpecReduce_3 #-}
{-# NOINLINE happyReduce #-}
{-# NOINLINE happyMonadReduce #-}
{-# NOINLINE happyGoto #-}
{-# NOINLINE happyFail #-}

-- end of Happy Template.
